# -*- coding: utf-8 -*-

#Constraint Helper V1.1

#updated: 8/11/17
#BY http://steamcommunity.com/id/OMGTheresABearInMyOatmeal/
#feel free to modify the script for your own use
#find any bugs or suggestions message me in the workshop page comments


from PySide import QtCore, QtGui
import os,ast
import vsUtils



class Ui_window(QtGui.QMainWindow):

    def error(self,e):
        
        #error box

        msgBox = QtGui.QMessageBox(QtGui.QMessageBox.Critical,
                "ERROR",  "\n"+str(e),
                QtGui.QMessageBox.NoButton, self)


        msgBox.addButton("&Continue", QtGui.QMessageBox.RejectRole)
        if msgBox.exec_() == QtGui.QMessageBox.AcceptRole:pass
        
    def Message(self,text):
        #message box

        msgBox = QtGui.QMessageBox(QtGui.QMessageBox.Information,
                "Success", text,
                QtGui.QMessageBox.NoButton, self)


        msgBox.addButton("&Continue", QtGui.QMessageBox.RejectRole)
        if msgBox.exec_() == QtGui.QMessageBox.AcceptRole:pass



    def open_script(self):#reads prev file made
        filename=None
        try:
            
            filename, foo = QtGui.QFileDialog.getOpenFileName(None,
                        "Load Constraint File", "platform\\scripts\\sfm\\animset\\", "(*.py)")
            if  filename:
                with open(filename, 'r') as fin:
                    fin= fin.readlines()

                text=fin[:6]#gets the first 6 lines

                for i in text :#finds the list
                    if "string_target_list" in i:
                        b=(i.find("["))
                        string_target_list=ast.literal_eval(i[b:])###gets the list
                    if "string_slave_list" in i:
                        b=(i.find("["))
                        string_slave_list=ast.literal_eval(i[b:])###gets the list
                    if "string_constraint_list" in i:
                        b=(i.find("["))
                        string_constraint_list=ast.literal_eval(i[b:])###gets the list
			break
		text=fin[:]#gets the first 6 lines
	

			
						

                ##loads the saved info to the gui
		
		
		if "puppet" in filename:
		    for i in fin[90:] :			
			if "puppet_animset_name=" in i:
			    b=(i.find('"'))
			    
			    puppet_name=i[b+1:-2]
			    
			    break
			else:
			    puppet_name="Null"		    
		    
		    
		    self.checkbox.setChecked(True)
		    index=self.animset_list.findText(puppet_name)
		    if index <0:
			self.error("Could not find this animset: "+puppet_name)
			return
		    else:
			self.animset_list.setCurrentIndex(index)
		    
		    
                self.Constraint_num.setValue(len(string_constraint_list))
		
		
		
		

                for index in range(len(string_constraint_list)):
                    comboxindex=self.target_list[index].findText(string_target_list[index])                    
                    self.target_list[index].setCurrentIndex(comboxindex)

                    comboxindex=self.slave_list[index].findText(string_slave_list[index])                    
                    self.slave_list[index].setCurrentIndex(comboxindex)
                    

                    comboxindex=self.constraint_list[index].findText(string_constraint_list[index])                    
                    self.constraint_list[index].setCurrentIndex(comboxindex)





        
        except any as e:
            print e
            return
















    def get_dags_from_animset(self,anmiset):
	#code from  revzin.net
	    rootDags = []
	    
	    
	    for attr in  anmiset.iterAttrs():
		    if attr.GetName() == "controls":
			    for control in attr:
				    control.cast();
				    if control.GetTypeString() == "DmeTransformControl":
					    # We do not want facial flexes.
					    rootDags.append(control.GetName())
	    return rootDags           

                        

                        
                
             
    def add_list_to_combobox(self,combobox,lst):
         for bonename in lst:
             combobox.addItem(bonename)


    def add_bone_names_to_combobox(self,combobox):
         for bonename in self.bonelist:
             combobox.addItem(bonename)


    def add_constaint_options(self,combobox):
        combobox.addItem("Aim Constraint")
        combobox.addItem("Orient Constraint")
        combobox.addItem("Parent Constraint")
        combobox.addItem("Point Constraint")

        #tooltip
        combobox.setItemData(0,"Create an aim constraint to make the slave's rotation follow the target", QtCore.Qt.ToolTipRole)
        combobox.setItemData(1,"Create an orientation constraint that constrains the orientation of the slaveDag to the orientation of the target", QtCore.Qt.ToolTipRole)
        combobox.setItemData(2,"Create a parent constraint that makes the slaveDag behave as if it were a child of the target DAG", QtCore.Qt.ToolTipRole)
        combobox.setItemData(3,"Create a point constraint that constrains the position of the slaveDag to the position of the target.", QtCore.Qt.ToolTipRole)



    def remove_row(self,t,s,c,r):#removes  row 
            ##removes the obj from the gui out of range
            
            t.deleteLater()
            s.deleteLater()
            c.deleteLater()
            r.deleteLater()

 
            ##deletes the list obj out of range
            index=self.target_list.index(t)
            self.target_list.pop(index)

            index=self.slave_list.index(s)
            self.slave_list.pop(index)


            index=self.constraint_list.index(c)
            self.constraint_list.pop(index)

            index=self.remove_list.index(r)
            self.remove_list.pop(index)

            
            self.Constraint_num.setValue(self.Constraint_num.value()-1)

        
    def insert_row(self):
        




        if len(self.target_list)>self.Constraint_num.value():
            ##removes the obj from the gui out of range
            for x in self.target_list[self.Constraint_num.value():]:
                x.deleteLater()                    
            for x in self.slave_list[self.Constraint_num.value():]:
                x.deleteLater()                    
            for x in self.constraint_list[self.Constraint_num.value():]:
                x.deleteLater()
            for x in self.remove_list[self.Constraint_num.value():]:
                x.deleteLater()                   

            ##deletes the list obj out of range    
            del  self.target_list[self.Constraint_num.value():]
            del self.slave_list[self.Constraint_num.value():]                
            del  self.constraint_list[self.Constraint_num.value():]
            del self.remove_list[self.Constraint_num.value():]


        
        for i in range(self.Constraint_num.value()):



            if len(self.target_list)>i:#to stop overlaping 
                continue






            
            ##add obj to list
            self.target_list.append(QtGui.QComboBox(self.scrollAreaWidgetContents))
            self.slave_list.append(QtGui.QComboBox(self.scrollAreaWidgetContents))
            self.constraint_list.append(QtGui.QComboBox(self.scrollAreaWidgetContents))
            self.remove_list.append(QtGui.QPushButton(self.scrollAreaWidgetContents))


            #adds data to combo box
            self.add_constaint_options(self.constraint_list[-1])
            self.add_bone_names_to_combobox(self.target_list[-1])
	    if self.checkbox.isChecked():
		self.add_list_to_combobox(self.slave_list[-1],self.daglist)
	    else:
		self.add_bone_names_to_combobox(self.slave_list[-1])
            self.target_list[-1].setMaxVisibleItems(30)
            self.slave_list[-1].setMaxVisibleItems(30)
            self.remove_list[-1].setText("Remove")

            #sets event for remove

            self.remove_list[-1].clicked.connect(lambda target=self.target_list[-1],slave=self.slave_list[-1],con=self.constraint_list[-1],rem=self.remove_list[-1]: self.remove_row(target,slave,con,rem))

            
            
            ##add obj to gui
            self.gridLayout.addWidget(self.target_list[-1],     i+2,0,1,1)
            self.gridLayout.addWidget(self.slave_list[-1],      i+2,1,1,1)
            self.gridLayout.addWidget(self.constraint_list[-1], i+2,2,1,1)
            self.gridLayout.addWidget(self.remove_list[-1],     i+2,3,1,1)
       












    def createfile(self):
        if len(self.target_list) < 1:
            self.error("no Constraints made")

            return




        
        string_target_list=[]
        string_slave_list=[]
        string_constraint_list=[]
        #gets the text string from each list
        for i in range(len(self.target_list)):
            string_target_list.append(self.target_list[i].currentText())
            string_slave_list.append(self.slave_list[i].currentText())
            if string_slave_list[i]==string_target_list[i] and not self.checkbox.isChecked():
                self.error("Target and slave cant be the same. Row "+str(i+1))
                return
                


            
            string_constraint_list.append(self.constraint_list[i].currentText())



        script="""
#created with Constraint Helper V1.1
import vsUtils
from PySide import QtCore, QtGui
def error(e):
    
    #error box

    msgBox = QtGui.QMessageBox(QtGui.QMessageBox.Critical,"ERROR",str(e), QtGui.QMessageBox.NoButton)


    msgBox.addButton("&Continue", QtGui.QMessageBox.RejectRole)
    if msgBox.exec_() == QtGui.QMessageBox.AcceptRole:pass

def CreateConstraint( target, slave,Constraint,bCreateControls=True, group=None ,offset=True,puppet=False,puppet_dagdir={}) :
    ''' Method for creating a single target orient constraint '''

    if ( target == None ):
        return
        
    
    
    targetDag = sfmUtils.FindFirstDag( [  target  ], True )
    
    
   
    if puppet:
        slaveDag =puppet_dagdir[slave]
        ConstraintGroup= puppet_animset.GetRootControlGroup().CreateControlGroup( "Constraints" )
        ConstraintGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)        
        puppet_animset.GetRootControlGroup().AddChild(ConstraintGroup)
        
        
    else:
        slaveDag = sfmUtils.FindFirstDag( [  slave  ], True )
        ConstraintGroup=rootGroup.CreateControlGroup( "Constraints" )
        ConstraintGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)
        rootGroup.AddChild(ConstraintGroup)
   
        
    sfmUtils.AddDagControlsToGroup(ConstraintGroup,slaveDag)
    ConstraintGroup.SetSelectable( False )
    ConstraintGroup.SetVisible( False )
    sfm.PushSelection()
    sfmUtils.SelectDagList( [ targetDag, slaveDag ] )
    
    if Constraint=='Aim Constraint':
        orientConstraintTarget = sfm.AimConstraint( controls=bCreateControls, mo=offset )
    elif Constraint=='Orient Constraint':
        orientConstraintTarget = sfm.OrientConstraint(controls=bCreateControls, mo=offset )
    elif Constraint=='Point Constraint':
        orientConstraintTarget = sfm.PointConstraint( controls=bCreateControls, mo=offset )       
    elif Constraint=='Parent Constraint':
        orientConstraintTarget = sfm.ParentConstraint( controls=bCreateControls, mo=offset )

   
        
    if ( group != None ):

        if ( orientConstraintTarget != None ):
            orientWeightControl = orientConstraintTarget.FindWeightControl()
            if ( orientWeightControl != None ):
                group.AddControl( orientWeightControl )

    sfm.PopSelection()
    return


def get_dag_list(child):
    for num in range(child.GetChildCount()):
            tmpDag = child.GetChild(num)
            if tmpDag == None:
                    break
            b=str(tmpDag.GetName()).find('(')
           
            bonename=str(tmpDag.GetName())[b+1:-1]

            
            puppet_dir[bonename]=tmpDag
            if tmpDag.GetChildCount()>0:
                    get_dag_list(tmpDag)


    
animSet = sfm.GetCurrentAnimationSet()
rootGroup = animSet.GetRootControlGroup()

enable_puppet=%s
puppet_animset_name="%s"

allAnimSets = []
puppet_dir={}
puppet_animset=None

if enable_puppet:
    shot = sfm.GetCurrentShot()
	    
	    # Empty array
    
    #code from  revzin.net
    for shotAttribute in shot.iterAttrs():
       if shotAttribute.GetName() == "animationSets": 
	  for animSet in shotAttribute:
	     if puppet_animset_name == animSet.GetName():
	         puppet_animset=animSet
	         break
    if  puppet_animset:
	get_dag_list(puppet_animset.gameModel)
    else:
	error("\\nCould not find this animset: "+puppet_animset_name)
        string_target_list=[]          
for i in range(len(string_target_list)):
    CreateConstraint(string_target_list[i],string_slave_list[i],string_constraint_list[i],puppet=enable_puppet,puppet_dagdir=puppet_dir)

"""%( str(self.checkbox.isChecked()),self.animset_list.currentText())






	if self.checkbox.isChecked():
	    name="puppet_rig_"+(self.animSet.GetName())[:-1]+".py"
	else:
	    name="constraint_rig_"+(self.animSet.GetName())[:-1]+".py"









        try:

            fob=open("platform\\scripts\\sfm\\animset\\" + name,"w")
            fob.write("\nstring_target_list= %s \nstring_slave_list= %s \nstring_constraint_list= %s"%(string_target_list,string_slave_list,string_constraint_list)+script)
            fob.close()




                
            self.Message("file "+ name + " was created and saved in\n game\\platform\\scripts\\sfm\\animset\\")
            

        except  IOError as e:

            self.error(e)


        except  UnicodeEncodeError as e:
            self.error(e)


        except  WindowsError as e:
            self.error(e)



    def update_boxes(self):
	if self.checkbox.isChecked():
	    
	    for elm in self.allAnimSets:
		if elm.GetName()==self.animset_list.currentText():
		    self.daglist=self.get_dags_from_animset(elm)
		    break
	    self.daglist.sort()
	    for combo in self.slave_list:
		combo.clear()
		self.add_list_to_combobox(combo,self.daglist)

    def toggle_puppet(self):
	if self.checkbox.isChecked():
	    self.update_boxes()
	    
	else:
	    for combo in self.slave_list:
		combo.clear()
		self.add_list_to_combobox(combo,self.bonelist)	    
		
    def match(self):
	#finds  bone matchs between the master and puppet
	if self.checkbox.isChecked():
	    macthlist= set(self.bonelist) & set(self.daglist)
	    self.Constraint_num.setValue(len(macthlist))
	    
	    index=0
	    
	    for elm in sorted(macthlist):
		comboxindex=self.target_list[index].findText(elm) 
		self.target_list[index].setCurrentIndex(comboxindex)
		    
		    
		    
		comboxindex=self.slave_list[index].findText(elm)		    
		self.slave_list[index].setCurrentIndex(comboxindex) 
		index+=1
    def constraintchange(self,key):
	#changes all the constrains to the same type ,shortcut
	for combo in self.constraint_list:
	    combo.setCurrentIndex(int(key.toString())-1)
		
    ##sets up gui
    def setupUi(self, window):
	
        window.setObjectName("window")
        window.resize(700, 400)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Preferred, QtGui.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(3)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(window.sizePolicy().hasHeightForWidth())
        window.setSizePolicy(sizePolicy)
        self.verticalLayout = QtGui.QVBoxLayout(window)
        self.verticalLayout.setObjectName("verticalLayout")
        self.horizontalLayout_2 = QtGui.QHBoxLayout()
        self.horizontalLayout_2.setSizeConstraint(QtGui.QLayout.SetNoConstraint)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.groupBox = QtGui.QGroupBox(window)
        self.groupBox.setMinimumSize(QtCore.QSize(412, 67))
        self.groupBox.setMaximumSize(QtCore.QSize(16777215, 67))
        self.groupBox.setObjectName("groupBox")
        self.horizontalLayout = QtGui.QHBoxLayout(self.groupBox)
        self.horizontalLayout.setSizeConstraint(QtGui.QLayout.SetMaximumSize)
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.label_4 = QtGui.QLabel(self.groupBox)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Maximum, QtGui.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_4.sizePolicy().hasHeightForWidth())
        self.label_4.setSizePolicy(sizePolicy)
        self.label_4.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_4.setObjectName("label_4")
        self.horizontalLayout.addWidget(self.label_4)
        self.Constraint_num = QtGui.QSpinBox(self.groupBox)
        
        self.Constraint_num.valueChanged[int].connect(self.insert_row)
        
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.Constraint_num.sizePolicy().hasHeightForWidth())
        self.Constraint_num.setSizePolicy(sizePolicy)
        self.Constraint_num.setCorrectionMode(QtGui.QAbstractSpinBox.CorrectToNearestValue)
        
        self.Constraint_num.setObjectName("Constraint_num")
        self.horizontalLayout.addWidget(self.Constraint_num)
        self.checkbox = QtGui.QCheckBox(self.groupBox)
        
        
        
        
        self.checkbox.setText("Toggle puppet")
        self.checkbox.setSizePolicy(QtGui.QSizePolicy(QtGui.QSizePolicy.Maximum, QtGui.QSizePolicy.Fixed))
        self.horizontalLayout.addWidget(self.checkbox)
        
        self.animset_list=QtGui.QComboBox(self.checkbox)
	self.animset_list.currentIndexChanged.connect(lambda:self.update_boxes())
        self.horizontalLayout.addWidget(self.animset_list)
        
        
        self.horizontalLayout_2.addWidget(self.groupBox)
        self.verticalLayout.addLayout(self.horizontalLayout_2)
        self.horizontalLayout_3 = QtGui.QHBoxLayout()
        self.horizontalLayout_3.setObjectName("horizontalLayout_3")
        self.boneBox = QtGui.QGroupBox(window)
        self.boneBox.setObjectName("boneBox")
        self.gridLayout_2 = QtGui.QGridLayout(self.boneBox)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.scrollArea = QtGui.QScrollArea(self.boneBox)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.MinimumExpanding, QtGui.QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(2)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.scrollArea.sizePolicy().hasHeightForWidth())
        self.scrollArea.setSizePolicy(sizePolicy)
        self.scrollArea.setWidgetResizable(True)
        self.scrollArea.setObjectName("scrollArea")
        self.scrollArea.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOn)
        self.scrollAreaWidgetContents = QtGui.QWidget()
        self.scrollAreaWidgetContents.setGeometry(QtCore.QRect(0, 0, 446, 117))
        self.scrollAreaWidgetContents.setObjectName("scrollAreaWidgetContents")
        self.gridLayout = QtGui.QGridLayout(self.scrollAreaWidgetContents)
        self.gridLayout.setObjectName("gridLayout")

        self.label = QtGui.QLabel(self.scrollAreaWidgetContents)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Preferred, QtGui.QSizePolicy.Maximum)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label.sizePolicy().hasHeightForWidth())
        self.label.setSizePolicy(sizePolicy)
        self.label.setFrameShape(QtGui.QFrame.NoFrame)
        self.label.setScaledContents(False)
        self.label.setAlignment(QtCore.Qt.AlignCenter)
        self.label.setObjectName("label")
        self.gridLayout.addWidget(self.label, 0, 0, 1, 1)
        
        self.label_2 = QtGui.QLabel(self.scrollAreaWidgetContents)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Maximum, QtGui.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_2.sizePolicy().hasHeightForWidth())
        self.label_2.setSizePolicy(sizePolicy)
        

        self.label_2.setAlignment(QtCore.Qt.AlignCenter)
        self.gridLayout.addWidget(self.label_2, 0, 2, 1, 1)
        
        self.label_3 = QtGui.QLabel(self.scrollAreaWidgetContents)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Preferred, QtGui.QSizePolicy.Maximum)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.label_3.sizePolicy().hasHeightForWidth())
        self.label_3.setSizePolicy(sizePolicy)
        self.label_3.setAlignment(QtCore.Qt.AlignCenter)
        self.label_3.setObjectName("label_3")
        self.gridLayout.addWidget(self.label_3, 0, 1, 1, 1)
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
        self.gridLayout_2.addWidget(self.scrollArea, 1, 0, 1, 4)
        self.horizontalLayout_3.addWidget(self.boneBox)
        self.verticalLayout.addLayout(self.horizontalLayout_3)
        self.createscript = QtGui.QPushButton(window)
        self.createscript.setObjectName("createscript")
        
        font = QtGui.QFont()
        font.setPointSize(14)
        self.createscript.setFont(font)
        self.retranslateUi(window)
        QtCore.QMetaObject.connectSlotsByName(window)
        
        self.openscript = QtGui.QPushButton(window)
        
        self.verticalLayout.addWidget(self.openscript)
        self.verticalLayout.addWidget(self.createscript)
        font.setPointSize(10)
        self.openscript.setFont(font)
        self.openscript.setText("open script")


	self.animSet = sfm.GetCurrentAnimationSet()
        
	self.daglist=[]#for puppet

        self.bonelist=[] #holds models bone names
        
        tmpDag="null"
        while(tmpDag != None ):
            tmpDag = sfm.NextSelectedDag()
            if tmpDag == None:
                break
            b=str(tmpDag).find('(')
            e=str(tmpDag).find(')')
            bonename=str(tmpDag)[b+1:e]
            if "dme" in bonename.lower() :
                continue
            self.bonelist.append(bonename)

        self.bonelist.sort()

        ##obj row
        self.target_list=[]
        self.slave_list=[]
        self.constraint_list=[]
        self.remove_list=[]
        ###

        self.Constraint_num.setMinimum(1)

        self.createscript.clicked.connect(lambda: self.createfile())
        self.openscript.clicked.connect(lambda: self.open_script())




	self.allAnimSets = []
        
        shot = sfm.GetCurrentShot()
        
        # Empty array

        #code from  revzin.net
        for shotAttribute in shot.iterAttrs():
	    if shotAttribute.GetName() == "animationSets": 
		for animSet in shotAttribute:
		    if sfm.GetCurrentAnimationSet()== animSet:
			continue
		    self.allAnimSets.append(animSet)
		break
	
	
                  
        #Now all the Animation Sets are in the allAnimSets array :
              
        for animSet in self.allAnimSets :
	    self.animset_list.addItem(animSet.GetName())

	self.animset_list.setEnabled(False)
	QtCore.QObject.connect(self.checkbox, QtCore.SIGNAL("toggled(bool)"), self.animset_list.setEnabled)
	self.checkbox.clicked.connect(lambda: self.toggle_puppet())
	
	matchshorcut = QtGui.QShortcut(window)
	matchshorcut.setKey("m")
	matchshorcut.activated.connect(lambda: self.match())	
	
	aimshorcut = QtGui.QShortcut(window)
	aimshorcut.setKey("1")
	aimshorcut.activated.connect(lambda: self.constraintchange(aimshorcut.key()))
	
	
	Orishorcut = QtGui.QShortcut(window)
	Orishorcut.setKey("2")
	Orishorcut.activated.connect(lambda: self.constraintchange(Orishorcut.key()))
	parentshorcut = QtGui.QShortcut(window)
	parentshorcut.setKey("3")
	parentshorcut.activated.connect(lambda: self.constraintchange(parentshorcut.key()))
	
	
	
	pointshorcut = QtGui.QShortcut(window)
	pointshorcut.setKey("4")
	pointshorcut.activated.connect(lambda: self.constraintchange(pointshorcut.key()))
	
	
	
	
	
	

	
    def retranslateUi(self, window):

        window.setWindowTitle(QtGui.QApplication.translate("window", "Constraint Helper V1.1", None, QtGui.QApplication.UnicodeUTF8))
        self.groupBox.setTitle(QtGui.QApplication.translate("window", "options", None, QtGui.QApplication.UnicodeUTF8))
        self.label_4.setText(QtGui.QApplication.translate("window", "# of  Constraints", None, QtGui.QApplication.UnicodeUTF8))

        self.label.setText(QtGui.QApplication.translate("window", "Target", None, QtGui.QApplication.UnicodeUTF8))
        self.label_2.setText(QtGui.QApplication.translate("window", "Constraint type", None, QtGui.QApplication.UnicodeUTF8))
        
        self.label_3.setText(QtGui.QApplication.translate("window", "Slave", None, QtGui.QApplication.UnicodeUTF8))
        self.createscript.setText(QtGui.QApplication.translate("window", "create script", None, QtGui.QApplication.UnicodeUTF8))

	#self.matchshorcut.setShortcut(QtGui.QApplication.translate("window", "ctrl+m", None, QtGui.QApplication.UnicodeUTF8))


if __name__ == "__main__":
    import sys
    window = QtGui.QWidget()
    ui = Ui_window()
    ui.setupUi(window)
    window.show()


